{ nixpkgs, stdcxx, libc, upstream, toolchain }:

nixpkgs.stdenvNoCC.mkDerivation
  { name = "scummvm";

    src = nixpkgs.fetchFromGitHub
      { owner = "ehmry";
        repo = "scummvm";
        rev = "9e587c53316eb3ae41ae652ff079dbdbca2a8724";
        sha256 = "0vyjlq6hahhifr9vl74i6i7mgpnr89zxhs5jb7kkr68z3d4vnkgd";
      };

    nativeBuildInputs = with nixpkgs.buildPackages;
      [ toolchain pkgconfig ];

    buildInputs = [ upstream.dev libc.dev stdcxx.dev ];

    sourceRoot = "source/backends/platform/libretro/build";

     postUnpack = "chmod -R a+rwX source";

     enableParallelBuilding = true;
     makeFlags = [ "platform=genode" ];

    installPhase =
      ''
        mkdir -p $out/bin
        cp libretro.so $out/bin
      '';
  }
