{ preparePort, nixpkgs, upstream }:

let
  inherit (nixpkgs) fetchFromGitHub fetchgit;
  upstreamSrc = import ./../../upstream/src.nix { inherit fetchgit; };
in
preparePort {
  name = "egl";
  outputs = [ "dev" ];

  src = fetchFromGitHub {
    name = "EGL";
    owner = "KhronosGroup";
    repo = "EGL-Registry";
    rev = "d738c39fe25bab9f65bed2cb78c4db253bd473c4";
    sha256 = "1bb2pgv516i1p8x3171yj3gqkxqxqwg7q42ak627md4x3irmqf2q";
  };

  installPhase = ''
    mkdir -p $includedir $pkgconfigdir

    substituteAll ${./egl_api.pc.in} $pkgconfigdir/egl_api.pc

    cp -r api/1.? api/EGL api/KHR $includedir
    cp ${upstream.src}/repos/libports/include/EGL/eglplatform.h $includedir/EGL/eglplatform.h
  '';
}
