{ preparePort, nixpkgs, toolchain, upstream }:

let
  version = "0.6.0";
in
preparePort {
  name = "libm-" + version;
  outputs = [ "dev" ];
  inherit version;

  src = nixpkgs.fetchFromGitHub {
    owner = "JuliaMath";
    repo = "openlibm";
    rev = "a96f0740e32c3d8aaa0a34c3988201018dfa90ce";
    sha256 = "08wfchmmr5200fvmn1kwq9byc1fhsq46hn0y5k8scdl74771c7gh";
  };

  depsBuildBuild = with nixpkgs.buildPackages; [ stdenv.cc toolchain ];

  buildPhase =
    ''
      mkdir -p $pkgconfigdir
      compileStub ${./libm.symbols} $dev/lib/libm.lib.so
      substituteAll ${./libm.pc.in} $pkgconfigdir/libm.pc
    '';

  installPhase =
    ''
      cp -rv include $dev/
    '';
}
